(function() {
  var parseURLParams;
  exports.urlMatchesScheme = function(url, schemeTemplate) {
    var result;
    url = url.replace(/\?.*$/, '');
    if (url === schemeTemplate) {
      return true;
    }
    result = new RegExp("^" + schemeTemplate.replace(/:(\w|_)+/g, "([^\/]+)") + '(\\.(\\w+))*$').test(url) ? true : false;
    return result;
  };
  exports.build = function(url, schemeTemplate) {
    var i, matcher, params, scheme, schemeTemplateParts, urlParts, _ref;
    urlParts = url.split('?')[0].split('/');
    params = url.split('?')[1];
    scheme = parseURLParams({}, params);
    schemeTemplateParts = schemeTemplate.split('/');
    matcher = new RegExp(/:(\w|_)+/);
    for (i = 0, _ref = schemeTemplateParts.length; (0 <= _ref ? i < _ref : i > _ref); i += 1) {
      if (matcher.test(schemeTemplateParts[i])) {
        scheme[schemeTemplateParts[i].slice(1, schemeTemplateParts[i].length)] = urlParts[i];
      }
    }
    return scheme;
  };
  parseURLParams = function(scheme, params) {
    var param, value, _i, _len;
    if ((params != null) && (params = params.split('&'))) {
      for (_i = 0, _len = params.length; _i < _len; _i++) {
        param = params[_i];
        value = param.split('=')[1];
        scheme[param.split('=')[0]] = value || "";
      }
    }
    return scheme;
  };
}).call(this);
